﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace AnalysisApplication
{
    public class CSVWriter : ResultsWriter
    {
        TextWriter tw;
        List<string> variableNames;
        bool initialised;

        public CSVWriter(string fileName)
        {
            tw = new StreamWriter(fileName, true);
            variableNames = new List<string>();
            initialised = false;
        }

        public override void WriteResults(Dictionary<string, string> results)
        {

            string s = "";
            if (!initialised)
            {
                variableNames.AddRange(results.Keys);
                if (variableNames.Count != 0)
                {
                    s += variableNames[0];
                }
                for (int i = 1; i < variableNames.Count; i++)
                {
                    s+="," + variableNames[i];
                }
                tw.WriteLine(s);
                s = "";
                initialised = true;
            }
            if (variableNames.Count != 0)
            {
                s += results[variableNames[0]];
            }
            for (int i = 1; i < variableNames.Count; i++)
            {
                s += "," + results[variableNames[i]];
            }
            tw.WriteLine(s);            
        }

        public void AnalysisFinished()
        {
            tw.Flush();
            tw.Close();
        }
    }
}
