﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AnalysisApplication
{
    /**
     * This class defines default implementations for visiting
     * each of the objects in the SessionModel.
     * A visitor should override the methods necessary to collect
     * the information they require.
     */
    public abstract class DefaultModelVisitor
    {
        public virtual void VisitSessionModel(SessionModel m)
        {
        }

        public virtual void VisitProjectSession(ProjectSession p)
        {
        }

        public virtual void VisitFileView(FileView f)
        {
        }

        public virtual void VisitProjectLaunch(ProjectLaunch p)
        {
        }

        public virtual void Attach10MinuteObserver(IVisitorObserver v)
        {
        }

        public virtual void AttachSummaryObserver(IVisitorObserver v)
        {
        }

        public abstract void ModelElementEnd(ModelElement e);

        public virtual Dictionary<string, string> GetSessionData()
        {
            return new Dictionary<string,string>();
        }

        public virtual Dictionary<string, string> Get10MinuteData()
        {
            return new Dictionary<string, string>();
        }
    }
}
