﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AnalysisApplication
{
    public class FileView : LowLevelModelElement
    {
        private DateTime start;
        private DateTime end;
        private string file;
        private string project;
        private string package;
        private string className;
        private int revisionNumber;

        public FileView(IDEEvent e)
        {
            start = e.timestamp;
            file = e.fileLocation;
            project = e.projectName;
            package = e.packageName;
            revisionNumber = e.revisionNumber;
            if (e.className == "")
            {
                className = file.Substring(file.LastIndexOf('/'));
            }
            else
            {
                className = e.className;
            }
        }


        public void FileViewStopped(IDEEvent e)
        {
            end = e.timestamp;
        }
        #region getters

        public override DateTime Timestamp
        {
            get { return start; }
        }

        public TimeSpan Duration
        {
            get
            {
                return end.Subtract(start);
            }
        }
        public string File
        {
            get
            {
                return file;
            }
        }
        public string Project
        {
            get
            {
                return project;
            }
        }
        public string ClassNome
        {
            get
            {
                return className;
            }
        }
        public int RevisionNumber
        {
            get
            {
                return revisionNumber;
            }
        }
#endregion Getters

        public override void Accept(DefaultModelVisitor v)
        {
            v.VisitFileView(this);
        }
    }
}
