﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AnalysisApplication
{
    public class IDEEvent : IComparable<IDEEvent>
    {
        public string kind = "";
        public string type = "";
        public string action = "";
        public DateTime timestamp;
        public string fileLocation = "";
        public string projectName = "";
        public string packageName = "";
        public string className = "";
        public string methodName = "";
        public int lineNumber;
        public int revisionNumber;

        public Dictionary<string, double> doubleData;
        public Dictionary<string, string> stringData;

        public IDEEvent()
        {
            doubleData = new Dictionary<string, double>();
            stringData = new Dictionary<string, string>();
        }

        #region IComparable<IDEEvent> Members

        public int CompareTo(IDEEvent other)
        {
            if (this == other) { return 0; }
            else if (other == null)
            {
                return -1;
            }
            else if (!(timestamp.CompareTo(other.timestamp) == 0))
            {
                return timestamp.CompareTo(other.timestamp);
            }
            else if (action.Contains("Start"))
            {
                if (other.action.Contains("Start"))
                {
                    if(type.Contains("Session")){
                        return -1;
                    }
                    else if (other.type.Contains("Session"))
                    {
                        return 1;
                    }
                    else if (type.Contains("Project"))
                    {
                        return -1;
                    }
                    else if (other.type.Contains("Project"))
                    {
                        return 1;
                    }
                    return 0;
                }
                if (other.action.Contains("Stop"))
                {
                    return 1;
                }
                return 1;
            }
            else if (action.Contains("Stop"))
            {
                if (other.action.Contains("Stop"))
                {
                    if (type.Contains("Session"))
                    {
                        return 1;
                    }
                    else if (other.type.Contains("Session"))
                    {
                        return -1;
                    }
                    else if (type.Contains("Project"))
                    {
                        return 1;
                    }
                    else if (other.type.Contains("Project"))
                    {
                        return -1;
                    }
                    return 0;
                }
                return -1;
            }
            return 0;
        }

        #endregion
    }
}
