﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AnalysisApplication
{
    class AnalysisApplication
    {
        static void Main(string[] args)
        {
            EventLoader l;
            List<CSVWriter> writers;
            writers = new List<CSVWriter>();
            FileEventLoader fel = new XMLEventLoader(@"..\ExtractedFiles");
            l = new ZipFileEventLoader(fel, @"ljp51");
           // l = fel;
            if (!l.Initialise())
            {
                return;
            }

            DefaultModelVisitor v = new FileViewVisitor();

            Summary summary = new SessionSummary();
            v.AttachSummaryObserver(summary);
            writers.Add(new CSVWriter("SessionData.csv"));
            summary.AddWriter(writers[0]);

            summary = new TenMinuteSummary();
            writers.Add(new CSVWriter("TenMinuteData.csv"));
            summary.AddWriter(writers[1]);
            v.Attach10MinuteObserver(summary);

            List<IDEEvent> events = l.NextSession();
            while (events != null)
            {
                SessionModel s = new SessionModel(events);
                s.Accept(v);
                events = l.NextSession();
            }
            foreach (CSVWriter w in writers)
            {
                w.AnalysisFinished();
            }
        }
    }
}
