﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AnalysisApplication
{
    public enum LaunchMode { Run, Debug }
    public class ProjectLaunch : LowLevelModelElement
    {
        private DateTime launchTime;
        private LaunchMode launchMode; 
        private bool exceptionThrown = false;
        private string file;

        public ProjectLaunch(IDEEvent e)
        {
            launchTime = e.timestamp;
            file = e.fileLocation;
            if(e.stringData["LaunchMode"]=="run")
            {
                launchMode = LaunchMode.Run;
            }
            else
            {
                launchMode = LaunchMode.Debug;
            }
        }

        public void AddOutput(IDEEvent e)
        {
            if (e.action.Contains("Exception"))
            {
                exceptionThrown = true;
            }
        }

        public override DateTime Timestamp
        {
            get { return launchTime; }
        }

        public override void Accept(DefaultModelVisitor v)
        {
            v.VisitProjectLaunch(this);
        }
    }
}
