﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AnalysisApplication
{
    public class SessionSummary : Summary
    {
        private List<ResultsWriter> writers;

        public SessionSummary()
        {
            writers = new List<ResultsWriter>();
        }

        public override void AddWriter(ResultsWriter w)
        {
            writers.Add(w);
        }

        public override void UpdateSummary(DefaultModelVisitor v)
        {
            foreach (ResultsWriter w in writers)
            {
                w.WriteResults(v.GetSessionData());
            }
        }
    }
}
